version: "3"
services:
  init:
    container_name: keyoxide-init
    image: nginx:1.19.6
    entrypoint:
      - /bin/sh
      - /init.sh
    #user: "1000"
    environment:
      - SERVER_NAME=${DOMAIN_NAME}
      - GPG_KEY=${GPG_KEY}
      - HTTP_PORT_MAP=${HTTP_PORT_MAP}
      - HTTPS_PORT_MAP=${HTTPS_PORT_MAP}
    volumes:
      - nginx-confd:/tmp/nginx-conf.d
      - letsencrypt:/tmp/letsencrypt
      - ./bin/init.sh:/init.sh
      - ./config/default.ssl.conf.tmpl:/tmp/default.ssl.conf.tmpl
      - ./config/default.conf.tmpl:/tmp/default.conf.tmpl
  certbot:
    container_name: keyoxide-certbot
    image: certbot/certbot:v1.11.0
    command: certonly --webroot -w /www --cert-name keyoxide -d ${DOMAIN_NAME} -m ${EMAIL} -n --agree-tos ${EXTRA_ARGS}
    #user: "101"
    volumes:
      - ./certbot/config:/config
      - ./certbot/logs:/etc/letsencrypt/logs
      - www-dir:/www
      - letsencrypt:/etc/letsencrypt/
    depends_on:
      - web-proxy
  web-proxy:
    container_name: keyoxide-proxy
    image: nginx:1.19.6
    #user: "nginx"
    ports:
      - 0.0.0.0:${HTTP_PORT_MAP}
      - 0.0.0.0:${HTTPS_PORT_MAP}
    networks:
      - local
    volumes:
      - ./config/nginx.conf:/etc/nginx/nginx.conf
      - nginx-confd:/etc/nginx/conf.d
      - www-dir:/usr/share/nginx/html
      - letsencrypt:/etc/letsencrypt
    depends_on:
      - init
  keyoxide:
    container_name: keyoxide-web
    image: keyoxide/keyoxide:2.4.1
    user: "node"
    ports:
      - 127.0.0.1:3000:3000
    networks:
      - local

volumes:
  letsencrypt:
  www-dir:
  nginx-confd:
networks:
  local:
